; ****************************************************************************
; ******                                                                ******
; ******                      - JACK! THE RIPPER -                      ******
; ******                 By Alain BROBECKER. (aka baah)                 ******
; ******                      v1.3  13 januar 1996                      ******
; ******                                                                ******
; ****************************************************************************

            include rincbin.inc
            scr_height=200
            max_filesize=400        ; In Kb.

            .386


; ****************************************************************************
; *******************************              *******************************
; *******************************     CODE     *******************************
; *******************************              *******************************
; ****************************************************************************
THE_CODE    SEGMENT USE16
            Assume CS:THE_CODE,SS:THE_STACK

beginning:
  mov       code_seg,cs

  mov       ax,0305h                ; Set keyboard repetition speed.
  mov       bx,0001h
  int       16h

;========> RELEASE UNUSED MEMORY. <==========================================
  mov       bx,ss                   ; Calculate the size between the end of
  mov       ax,es                   ; stack and the beginning of psp.
  sub       bx,ax
  mov       ax,sp                   ; Calculate end of stack.
  shr       ax,4
  inc       ax                      ; In case stack is not a multiple of 16.
  add       bx,ax                   ; Here bx=size of proggy/16.
  mov       ah,4ah                  ; Allocated memory modify function.
  int       21h
  jC        error

;========> LOAD FILE. <======================================================
; Check if command line contains a filename. In this case we load it, and
; go on with the ripper.
  mov       bl,byte ptr es:[80h]    ; bl=nb of bytes in command line.
  cmp       bl,0                    ; Command line is empty?
  jE        ripper_start            ; Then go on.
  xor       bh,bh                   ; bx=nb of bytes in command line
  mov       byte ptr es:[bx+81h],0  ; Put 0 at the end of command line.
  mov       ax,es                   ; Make ds:dx point on filename.
  mov       ds,ax
  mov       dx,82h
  mov       ax,003d00h              ; Open file function. (Read only)
  int       21h
  jC        error
  mov       bx,ax                   ; bx=file handle.
  push      bx                      ; Save it.
  mov       ax,4202h                ; Get size of file.
  xor       cx,cx
  xor       dx,dx
  int       21h                     ; Here dx:ax=file size.
  jC        error
  shl       edx,16                  ; Merge the two long words.
  mov       dx,ax
  mov       edi,edx                 ; edi=file size.
  mov       ax,4200h                ; Restore file pointer.
  xor       dx,dx
  int       21h
  jC        error
  cmp       edi,max_filesize*1024   ; File too big?
  jLE       @@filesize_ok

; ICI, DEMANDEZ AU USER A PARTIR DE OU CHARGER LE FICHIER.
; ON FAIT ALORS POINTER AU BON ENDROIT, ON MET max_filesize DANS edi,
; ET ON CONTINUE.

@@filesize_ok:
  xor       eax,eax                 ; Fuck the upperword.
  mov       ebx,edi
  shr       ebx,4                   ; bx=nb of segments to allocate-1.
  inc       bx
  mov       ah,48h                  ; MemAlloc function.
  int       21h
  jC        error
  mov       si,ax                   ; Make si:dx point on buffer.
  xor       dx,dx
  shl       eax,4                   ; eax=adress of buffer.
  mov       buffer_base,eax         ; Save buffer adress.
  pop       bx                      ; bx=handle.
  mov       ecx,32768               ; ecx=nb of bytes to read.
@@read_32768:
  sub       edi,ecx                 ; Size-=32768.
  jLE       @@read_last             ; No more than 32768 bytes read?
  mov       ah,3fh                  ; Read function.
  mov       ds,si                   ; ds=segment buffer.
  int       21h
  jC        error
  add       si,32768/16             ; buffer adress+=32768.
  jmp       @@read_32768
@@read_last:
  add       cx,di                   ; cx=nb of bytes left to read.
  mov       ah,3fh                  ; Read function.
  mov       ds,si                   ; ds=segment buffer.
  int       21h
  jC        error
  mov       ah,3eh                  ; Close file function.
  int       21h
  jC        error

;========> JACK! THE RIPPER <================================================
ripper_start:
  mov       es,video_seg            ; es=screen_segment.
  mov       eax,buffer_base         ; Initialise bases.
  mov       ram_base,eax
  mov       color_base,eax
  jmp       display_help

redrawing:
  call      redraw_screen           ; Redraw the entire screen.
small_redrawing:
  mov       bx,video_base           ; Change videoram adress.
  shr       bx,2
  mov       dx,03d4h                ; CRT Controller.
  mov       al,0ch                  ; Start adress high subregister.
  mov       ah,bh
  out       dx,ax
  inc       al                      ; Start adress low subregister.
  mov       ah,bl
  out       dx,ax
wait_keyboard:
  mov       ah,01h                  ; Wait until a char is in keyboard buffer.
  int       16h
  jZ        wait_keyboard
  xor       ah,ah                   ; Read char.
  int       16h

;----> Width and Modulo operations. <-------------
  cmp       al,31h                  ; Decrement width? (1)
  jE        dec_width
  cmp       al,32h                  ; Increment width? (2)
  jE        inc_width
  cmp       al,33h                  ; Restore width? (3)
  jE        restore_width
  cmp       al,34h                  ; Decrement modulo? (4)
  jE        dec_modulo
  cmp       al,35h                  ; Increment modulo? (5)
  jE        inc_modulo
  cmp       al,36h                  ; Reset modulo? (6)
  jE        restore_modulo

;----> Scrolling operations. <-------------
  cmp       al,30h                  ; Restore ram_base? (0)
  jE        restore_ram
  cmp       ax,5000h                ; Scroll one line up? (up)
  jE        scroll_up
  cmp       ax,4800h                ; Scroll one line down? (down)
  jE        scroll_down
  cmp       ax,5100h                ; Scroll one page up? (page up)
  jE        fast_scroll_up
  cmp       ax,4900h                ; Scroll one page down? (page down)
  jE        fast_scroll_down
  cmp       ax,7400h                ; Scroll one column left? (ctrl+left)
  jE        scroll_left
  cmp       ax,7300h                ; Scroll one column right? (ctrl+right)
  jE        scroll_right
  cmp       ax,4d00h                ; Scroll 4 columns left? (left)
  jE        fast_scroll_left
  cmp       ax,4b00h                ; Scroll 4 columns right? (right)
  jE        fast_scroll_right

;----> Colors operations. <----------------
  cmp       ax,3b00h                ; Set color to greyscale1? (f1)
  jE        greys1
  cmp       ax,3c00h                ; Set color to greyscale2? (f2)
  jE        greys2
  cmp       ax,3d00h                ; Set color base? (f3)
  jE        set_color_base
  cmp       al,37h                  ; Decrement color base? (7)
  jE        dec_color_base
  cmp       al,38h                  ; Increment color base? (8)
  jE        inc_color_base
  cmp       al,39h                  ; Restore color base?
  jE        restore_color

; IL FAUT AUSSI FAIRE DES TRUCS POUR ALLER EN 3 PAR 3, PIS AUSSI UNE
; RECHERCHE AUTOMATIQUE?

;----> Misc operations <----------
  cmp       al,73h                  ; Save displayed file? (s)
  jE        save_file
  cmp       ax,4400h                ; Show help? (f10)
  jE        display_help

  cmp       al,1bh                  ; Escape key pressed?
  jNE       small_redrawing
proggy_end:
  mov       ax,3h                   ; Back to text mode.
  int       10h
  mov       ah,4ch                  ; Terminate proggy function.
  int       21h


; ****************************************************************************
; ****************************************************************************
; ****************************************************************************
; ****************************************************************************
; ****************************************************************************

;========> DISPLAY HELP <====================================================
display_help:
  mov       ax,3h                   ; Back to text mode.
  int       10h
  mov       ds,code_seg             ; Make ds:dx point on message.
  mov       dx,offset cs:help_msg
  mov       ah,09h                  ; Print string function.
  int       21h
help_wait_kbd:
  mov       ah,01h                  ; Keyboard scan.
  int       16h
  jz        help_wait_kbd
  xor       ah,ah                   ; Read char.
  int       16h
  mov       ax,13h                  ; Initialise screen.
  int       10h                     ; 320*200, linear mode.
  mov       ax,img_width            ; Load image width.
  shl       ax,5                    ; ah=img_width/3.
  mov       dx,03d4h                ; Crt Controller Index.
  mov       al,13h                  ; Offset subregister.
  out       dx,ax                   ; Change virtual width.
  call      put_palette             ; Put palette.
  jmp       redrawing


;========> WIDTH OPERATIONS <================================================
dec_width:
  mov       ax,img_width            ; Load previous width.
  sub       ax,8                    ; img_width-=8.
  jLE       wait_keyboard           ; No change if result is negative.
  mov       img_width,ax            ; Save new width.
  shl       ax,5                    ; ah=img_width/3.
  mov       dx,03d4h                ; Crt Controller Index.
  mov       al,13h                  ; Offset subregister.
  out       dx,ax                   ; Change virtual width.
  jmp       redrawing

inc_width:
  mov       ax,img_width            ; Load previous width.
  add       ax,8                    ; img_width+=8.
  cmp       ax,320
  jG        wait_keyboard           ; No change if img_width>320.
  mov       img_width,ax            ; Save new width.
  shl       ax,5                    ; ah=img_width/3.
  mov       dx,03d4h                ; Crt Controller Index.
  mov       al,13h                  ; Offset subregister.
  out       dx,ax                   ; Change virtual width.
  jmp       redrawing

restore_width:
  mov       img_width,320           ; Restore width.
  mov       dx,03d4h                ; Crt Controller Index.
  mov       ax,02813h               ; Offset subregister.
  out       dx,ax                   ; Change virtual width.
  jmp       redrawing


;========> MODULO OPERATIONS <===============================================
dec_modulo:
  mov       ax,img_modulo           ; Load previous modulo.
  dec       ax                      ; img_modulo-=1.
  jL        small_redrawing         ; No change if result is negative.
  mov       img_modulo,ax           ; Save new modulo.
  jmp       redrawing

inc_modulo:
  inc       img_modulo              ; img_modulo+=1.
  jmp       redrawing

restore_modulo:
  mov       img_modulo,0            ; img_modulo=0.
  jmp       redrawing


;========> SCROLLING OPERATIONS <============================================
scroll_up:
  xor       eax,eax
  mov       ax,img_width
  add       video_base,ax           ; video_base+=width.
  add       ax,img_modulo           ; eax=width+modulo.
  add       ram_base,eax            ; ram_base+=(width+modulo).
  mov       bx,scr_height-1         ; Draw the line which appears.
  call      draw_line
  jmp       small_redrawing

scroll_down:
  xor       eax,eax
  mov       ax,img_width
  sub       video_base,ax           ; video_base-=width.
  add       ax,img_modulo           ; eax=width+modulo.
  sub       ram_base,eax            ; ram_base-=(width+modulo).
  jGE       @@scroll_down_ok
  mov       ram_base,0              ; In case ram_base<0, set it to 0
  jmp       redrawing               ; and redraw the screen.
@@scroll_down_ok:
  xor       bx,bx                   ; Draw the line which appears.
  call      draw_line
  jmp       small_redrawing

fast_scroll_up:
  mov       ax,img_width
  add       ax,img_modulo           ; ax=(width+modulo).
  mov       bx,scr_height
  mul       bx                      ; dx:ax=(width+modulo)*height.
  shl       edx,16
  mov       dx,ax                   ; edx=(width+modulo)*height.
  add       ram_base,edx            ; ram_base+=(width+modulo)*height.
  jmp       redrawing

fast_scroll_down:
  mov       ax,img_width
  add       ax,img_modulo           ; ax=(width+modulo).
  mov       bx,scr_height
  mul       bx                      ; dx:ax=(width+modulo)*height.
  shl       edx,16
  mov       dx,ax                   ; edx=(width+modulo)*height.
  sub       ram_base,edx            ; ram_base-=(width+modulo)*height.
  jGE       redrawing
  mov       ram_base,0
  jmp       redrawing

scroll_left:
  inc       ram_base                ; ram_base+=1.
  jmp       redrawing

scroll_right:
  dec       ram_base                ; ram_base-=1.
  jGE       redrawing
  mov       ram_base,0              ; If ram_base was<0, set it to 0.
  jmp       redrawing

fast_scroll_left:
  mov       edx,ram_base
  mov       ecx,edx
  add       ecx,4                   ; ecx=ram_base+4.
  mov       ram_base,ecx
  mov       di,video_base
  mov       cx,di
  add       cx,4                    ; cx=video_base+4.
  mov       video_base,cx
  xor       eax,eax
  mov       ax,img_width
  mov       ebx,eax
  add       bx,img_modulo           ; ebx=width+modulo.
  add       di,ax                   ; di=new_video_base+img_width-4.
  add       edx,eax                 ; edx=new_ram_base+img_width-4.
  sub       ax,4                    ; ax=img_width-4.
  mov       cl,scr_height           ; Nb of lines.
@@fast_left_loop:
  mov       esi,edx                 ; Make ds:si=edx.
  shr       esi,4                   ;   si=(width+modulo)*line_nb/16.
  mov       ds,si                   ;   ds=(width+modulo)*line_nb/16.
  mov       si,dx
  and       si,0fh                  ;   si=(width+modulo)*line_nb mod16.
  movsb                             ; Copy 4 pixels.
  movsb
  movsb
  movsb
  add       di,ax                   ; dest+=width-4.
  add       edx,ebx                 ; src+=width+modulo.
  dec       cl                      ; One line processed.
  jNE       @@fast_left_loop
  jmp       small_redrawing

fast_scroll_right:
  mov       edx,ram_base
  sub       edx,4                   ; edx=ram_base-4.
  jGE       @@fast_right_ok
  mov       ram_base,0
  jmp       redrawing
@@fast_right_ok:
  mov       ram_base,edx
  mov       di,video_base
  sub       di,4                    ; di=video_base-4.
  mov       video_base,di
  xor       eax,eax
  mov       ax,img_width
  mov       ebx,eax
  add       bx,img_modulo           ; ebx=width+modulo.
  sub       ax,4                    ; ax=img_width-4.
  mov       cl,scr_height           ; Nb of lines.
@@fast_right_loop:
  mov       esi,edx                 ; Make ds:si=edx.
  shr       esi,4                   ;   si=(width+modulo)*line_nb/16.
  mov       ds,si                   ;   ds=(width+modulo)*line_nb/16.
  mov       si,dx
  and       si,0fh                  ;   si=(width+modulo)*line_nb mod16.
  movsb                             ; Copy 4 pixels.
  movsb
  movsb
  movsb
  add       di,ax                   ; dest+=width-4.
  add       edx,ebx                 ; src+=width+modulo.
  dec       cl                      ; One line processed.
  jNE       @@fast_right_loop
  jmp       small_redrawing

restore_ram:
  mov       eax,buffer_base         ; Restore ram base.
  mov       ram_base,eax
  jmp       redrawing


;========> COLORS OPERATIONS <===============================================
greys1:
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       al,0                    ; al=color counter.
@@greys1_loop:
  mov       cx,3*4                  ; 4 colors at same grey value.
  rep stosb
  inc       al                      ; 4 colors set.
  cmp       al,64
  jNZ       @@greys1_loop
  jmp       color_end

greys2:
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       al,0                    ; al=color counter.
@@greys2_loop:
  stosb                             ; Save grey value.
  stosb
  stosb
  inc       al                      ; One grey copied.
  jNZ       @@greys2_loop           ; Continue until al=256=0.
  jmp       color_end

set_color_base:
  mov       eax,ram_base
  mov       color_base,eax
  mov       si,ax                   ; Make ds:si point on color_base.
  and       si,0fh
  shr       eax,4
  mov       ds,ax
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       cx,256*3                ; Copy palette.
  rep movsb
  jmp       color_end

dec_color_base:
  mov       eax,color_base          ; Load previous modulo.
  sub       eax,3                   ; color_base-=3.
  jL        color_end               ; No change if result is negative.
  mov       color_base,eax          ; Save new color_base.
  mov       si,ax                   ; Make ds:si point on color_base.
  and       si,0fh
  shr       eax,4
  mov       ds,ax
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       cx,256*3                ; Copy palette.
  rep movsb
  jmp       color_end

inc_color_base:
  mov       eax,color_base          ; Load previous modulo.
  add       eax,3                   ; color_base+=3.
  mov       color_base,eax          ; Save new color_base.
  mov       si,ax                   ; Make ds:si point on color_base.
  and       si,0fh
  shr       eax,4
  mov       ds,ax
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       cx,256*3                ; Copy palette.
  rep movsb
  jmp       color_end

restore_color:
  mov       eax,buffer_base         ; Restore color base.
  mov       color_base,eax
  mov       si,ax                   ; Make ds:si point on color_base.
  and       si,0fh
  shr       eax,4
  mov       ds,ax
  mov       es,code_seg             ; Make es:di point on sci_palette.
  mov       di,offset cs:sci_palette
  mov       cx,256*3                ; Copy palette.
  rep movsb

color_end:
  call      put_palette
  mov       es,video_seg            ; Restore es on video segment.
  jmp       small_redrawing


;-----------------------------------------------------------------------------
save_file:
  call      redraw_screen           ; Redraw image at top of videoram.
  mov       ah,3ch                  ; Create file.
  xor       cx,cx                   ;   normal file.
  mov       di,cs                   ;   ds:dx points on filename.
  mov       ds,di
  mov       dx,offset cs:filename
  int       21h
  jC        error
  mov       bx,ax                   ; bx=file handle.
  mov       di,dx
  inc       byte ptr ds:[di]        ; Change name for next file.
  mov       ah,40h                  ; Save sci header and palette.
  mov       cx,778                  ;   header is 778 bytes long.
  mov       dx,offset cs:sci_header ;   save cs:sci_header.
  int       21h
  jC        error
  mov       ax,img_width            ; Save raw image.
  mov       cx,scr_height
  mul       cx                      ;   ax=width*200=size of image.
  mov       cx,ax                   ;   size in cx.
  mov       ah,40h                  ;   function nb in ah.
  mov       di,es                   ;   save from 0a000:0000.
  mov       ds,di
  xor       dx,dx
  int       21h
  jC        error
  mov       ah,3eh                  ; Close file.
  int       21h
  jC        error
  jmp       small_redrawing

;========> ERROR <===========================================================
error:
  mov       ds,code_seg             ; Make ds:dx point on message.
  mov       dx,offset cs:error_msg
  mov       ah,09h                  ; Print string function.
  int       21h
  mov       ah,4ch                  ; Quit the proggy.
  int       21h



; ***************************************************************************
; *****************************                ******************************
; *****************************   PROCEDURES   ******************************
; *****************************                ******************************
; ***************************************************************************

;========> REDRAW SCREEN <===================================================
redraw_screen           PROC NEAR
  xor       di,di                   ; Set video base to 0.
  mov       video_base,di
  mov       ebp,ram_base            ; Put ram base in ds:si.
  mov       ax,scr_height           ; ax=nb of lines to copy.
  xor       ebx,ebx
  mov       bx,img_width            ; bx=nb of bytes to copy per line.
  mov       edx,ebx
  add       dx,img_modulo           ; edx=width+modulo.
@@copy_screen_loop:
  mov       si,bp
  and       si,0fh                  ; si=ram_base mod16.
  mov       ecx,ebp
  shr       ecx,4
  mov       ds,cx                   ; ds=int(ram_base/16).
  mov       cx,bx                   ; Nb of bytes to copy.
  rep movsb
  add       ebp,edx                 ; ram+=width+modulo.
  dec       ax                      ; One line copied.
  jNE       @@copy_screen_loop
  ret
redraw_screen           ENDP



;========> DRAW LINE <=======================================================
; bx - line nb. (0-scr_height-1)
draw_line               PROC NEAR
  mov       di,video_base           ; Make es:di point on dest.
  mov       ax,img_width            ;   width bytes per line.
  mul       bx                      ;   dx:ax=width*line_nb.
  add       di,ax                   ;   di=scr_offset+width*line_nb.
  mov       ax,img_width            ; Make ds:si point on src.
  add       ax,img_modulo
  mul       bx                      ;   dx:ax=(width+modulo)*line_nb.
  shl       edx,16
  mov       dx,ax                   ;   edx=(width+modulo)*line_nb.
  add       edx,ram_base
  mov       si,dx
  and       si,0fh                  ;   si=(width+modulo)*line_nb mod16.
  shr       edx,4                   ;   dx=(width+modulo)*line_nb/16.
  mov       ds,dx
  mov       cx,img_width            ; Copy img_width bytes.
  rep movsb
  ret
draw_line               ENDP



;========> PUT PALETTE <=====================================================
put_palette             PROC NEAR
  xor       cl,cl                   ; cl=color counter.
  mov       ds,code_seg             ; Make ds:si point on palette.
  mov       si,offset cs:sci_palette
  mov       dx,03c8h                ; Palette write port.
@@put_palette_one:
  mov       al,cl                   ; al=color to change.
  out       dx,al
  inc       dx
  lodsb                             ; Load red compound.
  out       dx,al
  lodsb                             ; Load red compound.
  out       dx,al
  lodsb                             ; Load red compound.
  out       dx,al
  dec       dx
  inc       cl                      ; One color changed.
  jne       @@put_palette_one       ; Change until cl=256=0.
  ret
put_palette             ENDP



; ***************************************************************************
; *******************************             *******************************
; *******************************    DATAS    *******************************
; *******************************             *******************************
; ***************************************************************************

code_seg    dw 0
video_seg   dw 0a000h   ; Segment value for videoram.
buffer_base dd 0        ; Adress of initial buffer. (0 or file adress)

video_base  dw 0
ram_base    dd 0        ; Adress of displayed memory.
color_base  dd 0        ; Adress of displayed color table.

img_modulo  dw 0



sci_header  db 'RIX3'               ; The following is the hader for files.
img_width   dw 320
img_height  dw scr_height
sci_zarbi   dw 175
sci_palette label byte
  incbin 'default.pal',3*256

filename    db '0.sci',0            ; Name of the file to save.

help_msg:
  db '                              - JACK! THE RIPPER -',13,10
  db '                         By Alain BROBECKER. (aka baah)',13,10
  db '                                v1.3  nov95-jan96',13,10
  db 10
  db '       *************************** SCROLLING ****************************',13,10
  db '         Page Up...........one page up    Page Down.......one page down',13,10
  db '         Up................one line up    Down............one line down',13,10
  db '         Left.........four pixels left    Right.......four pixels right',13,10
  db '         Ctrl-Left......one pixel left    Ctrl-Right....one pixel right',13,10
  db '         0............reset screenbase',13,10
  db '       ************************ WIDTH AND MODULO ************************',13,10
  db '         1.............decrement width    4............decrement modulo',13,10
  db '         2.............increment width    5............increment modulo',13,10
  db '         3...........reset width (320)    6............reset modulo (0)',13,10
  db '       ***************************** COLORS *****************************',13,10
  db '         f1.....greys palette (6 bits)    7.....dec color base (step 3)',13,10
  db '         f2.....greys palette (8 bits)    8.....inc color base (step 3)',13,10
  db '         f3.............set color base    9..........restore color base',13,10
  db '       ***************************** OTHERS *****************************',13,10
  db '         s..............save SCI image    Escape...................quit',13,10
  db '         f10............show this help'
  db '$'

error_msg:
  db        '**** ERROR! ****',13,10,'$'

THE_CODE    ENDS




; ***************************************************************************
; ***************************************************************************
; *******************************  STACK  ***********************************
; ***************************************************************************
; ***************************************************************************
THE_STACK   SEGMENT STACK

  db        128 dup(0)

THE_STACK               ENDS

                        END beginning
